## net.sf.saxon.om
Class NamespaceIterator

    java.lang.Object
      net.sf.saxon.om.NamespaceIterator

All Implemented Interfaces:
  AxisIterator, SequenceIterator, UnfailingIterator

    public class NamespaceIterator

extends java.lang.Object
implements AxisIterator

This class provides an implementation of the namespace axis over any implementation of the data model. It relies on element nodes to implement the method `NodeInfo.getDeclaredNamespaces(int[])`

Nested Class Summary
`static class` `NamespaceIterator.NamespaceNodeImpl` Inner class: a model-independent representation of a namespace node

Field Summary

Fields inherited from interface net.sf.saxon.om.SequenceIterator
`GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

Method Summary
`void` `advance()` Get the next item in the sequence.
`Value` `atomize()` Return the atomized value of the current node.
`void` `close()` Close the iterator.
`Item` `current()` Get the current item in the sequence.
`SequenceIterator` `getAnother()` Get another iterator over the same sequence of items, positioned at the start of the sequence
`static int[]` `getInScopeNamespaceCodes(NodeInfo element)` Get a list of in-scope namespace codes.
`int` `getProperties()` Get properties of this iterator, as a bit-significant integer.
`java.lang.CharSequence` `getStringValue()` Return the string value of the current node.
`AxisIterator` `iterateAxis(byte axis, NodeTest test)` Return an iterator over an axis, starting at the current node.
`static AxisIterator` `makeIterator(NodeInfo element, NodeTest test)` Factory method to create an iterator over the in-scope namespace nodes
`boolean` `moveNext()` Move to the next node, without returning it.
`Item` `next()` Get the next item in the sequence.
`int` `position()` Get the current position

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### makeIterator

    public static AxisIterator makeIterator(NodeInfo element,
                                            NodeTest test)

  Factory method to create an iterator over the in-scope namespace nodes

  Parameters:
    `element` - the node whose namespaces are required
    `test` - used to filter the returned nodes
  Returns:
    an iterator over the namespace nodes that satisfy the test

### advance

    public void advance()

  Get the next item in the sequence.

### moveNext

    public boolean moveNext()

  Move to the next node, without returning it. Returns true if there is a next node, false if the end of the sequence has been reached. After calling this method, the current node may be retrieved using the current() function.

  Specified by:
    `moveNext` in interface `AxisIterator`

### next

    public Item next()

  Get the next item in the sequence.

  Specified by:
    `next` in interface `SequenceIterator`
  Specified by:
    `next` in interface `UnfailingIterator`
  Returns:
    the next Item. If there are no more nodes, return null.

### current

    public Item current()

  Get the current item in the sequence.

  Specified by:
    `current` in interface `SequenceIterator`
  Specified by:
    `current` in interface `UnfailingIterator`
  Returns:
    the current item, that is, the item most recently returned by next()

### position

    public int position()

  Get the current position

  Specified by:
    `position` in interface `SequenceIterator`
  Specified by:
    `position` in interface `UnfailingIterator`
  Returns:
    the position of the current item (the item most recently returned by next()), starting at 1 for the first node

### close

    public void close()

  Description copied from interface: `SequenceIterator`
  Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

  (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

  Specified by:
    `close` in interface `SequenceIterator`

### iterateAxis

    public AxisIterator iterateAxis(byte axis,
                                    NodeTest test)

  Return an iterator over an axis, starting at the current node.

  Specified by:
    `iterateAxis` in interface `AxisIterator`
  Parameters:
    `axis` - the axis to iterate over, using a constant such as `Axis.CHILD`
    `test` - a predicate to apply to the nodes before returning them.
  Throws:
    `java.lang.NullPointerException` - if there is no current node

### atomize

    public Value atomize()
                  throws XPathException

  Return the atomized value of the current node.

  Specified by:
    `atomize` in interface `AxisIterator`
  Returns:
    the atomized value.
  Throws:
    `java.lang.NullPointerException` - if there is no current node
    `XPathException`

### getStringValue

    public java.lang.CharSequence getStringValue()

  Return the string value of the current node.

  Specified by:
    `getStringValue` in interface `AxisIterator`
  Returns:
    the string value, as an instance of CharSequence.
  Throws:
    `java.lang.NullPointerException` - if there is no current node

### getAnother

    public SequenceIterator getAnother()

  Get another iterator over the same sequence of items, positioned at the start of the sequence

  Specified by:
    `getAnother` in interface `SequenceIterator`
  Specified by:
    `getAnother` in interface `UnfailingIterator`
  Returns:
    a new iterator over the same sequence

### getProperties

    public int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Specified by:
    `getProperties` in interface `SequenceIterator`
  Returns:
    the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

### getInScopeNamespaceCodes

    public static int[] getInScopeNamespaceCodes(NodeInfo element)

  Get a list of in-scope namespace codes. If an array of namespace codes is needed, without actually constructing the namespace nodes, this factory method can be used directly. The result is an array of integers, each containing a prefix code in the top half and a uri code in the bottom half. Note that calling this method is destructive: the iterator is consumed and cannot be used again.

  Parameters:
    `element` - the element whose nodes are required
  Returns:
    the list of in scope namespaces

Copyright (c) Saxonica Limited. All rights reserved.